// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Kismet/BlueprintFunctionLibrary.h"
#include "MyBlueprintFunctionLibrary.generated.h"

class UDataTable;

UCLASS()
class MYPROJECT_API UMyBlueprintFunctionLibrary : public UBlueprintFunctionLibrary
{
	GENERATED_BODY()

public:

	UFUNCTION()
	static FString GetExportFileName(const UObject *Object, const FString &Extension);

	UFUNCTION()
	static void ImportJsonToObject(const FString &FilePath, UObject *OutObject);

	UFUNCTION()
	static void ExportObjectAsJson(const UObject *Object, const FString &OutputPath);

	UFUNCTION()
	static void ExportDataTableAsCSV(const UDataTable *Table);

protected:

	UFUNCTION()
	static void SaveStringToFile(const FString &String, const FString &FilePath);

	UFUNCTION()
	static bool LoadFileToString(const FString &FilePath, FString &OutString);

	UFUNCTION()
	static bool UObjectToJsonString(const UObject *Object, UStruct *ObjectStruct, FString &OutJsonString);

	UFUNCTION()
	static bool JsonStringToUObject(FString &JsonString, UStruct *ObjectStruct, const UObject *OutObject);
};
