// Fill out your copyright notice in the Description page of Project Settings.


#include "MyDataAsset.h"

#if WITH_EDITOR
#include "MyProject/MyBlueprintFunctionLibrary/MyBlueprintFunctionLibrary.h"
#include "MyProject/MyDataAsset/MyDataAssetFactory.h"
#include "MyProject/MySettings/MySettings.h"
#include "Windows/WindowsPlatformProcess.h"
#include "UObject/UnrealType.h"
#include "EditorFramework/AssetImportData.h"
#endif

#if WITH_EDITOR
FString UMyDataAsset::FileExtension = TEXT("myjson");

void UMyDataAsset::Import()
{
	FString FilePath = UMyBlueprintFunctionLibrary::GetExportFileName(this, FileExtension);
	UMyBlueprintFunctionLibrary::ImportJsonToObject(FilePath, this);
	UpdateAssetImportData(FilePath);
}

void UMyDataAsset::Export()
{
	FString FilePath = UMyBlueprintFunctionLibrary::GetExportFileName(this, FileExtension);
	UMyBlueprintFunctionLibrary::ExportObjectAsJson(this, FilePath);
	UpdateAssetImportData(FilePath);
}

void UMyDataAsset::OpenSourceLocation() const
{
	if (AssetImportData != nullptr)
	{
		FPlatformProcess::ExploreFolder(*AssetImportData->GetFirstFilename());
	}
}

void UMyDataAsset::PostEditChangeProperty(FPropertyChangedEvent &PropertyChangedEvent)
{
	if (PropertyChangedEvent.ChangeType == EPropertyChangeType::ArrayAdd)
	{
		// zvfǉuԂ͎GNX|[gȂiNbVj
		return;
	}

	const UMySettings *Settings = UMySettings::GetMySettings();
	if ((Settings != nullptr) && (Settings->AutoExportOnEdit))
	{
		Export();
	}
}

void UMyDataAsset::UpdateAssetImportData(FString Filename)
{
	if (AssetImportData == nullptr)
	{
		AssetImportData = NewObject<UAssetImportData>(this);
	}
	AssetImportData->Update(Filename);
}
#endif
