// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Engine/DataAsset.h"
#include "MyDataAsset.generated.h"

#if WITH_EDITOR
class UAssetImportData;
#endif

UCLASS()
class MYPROJECT_API UMyDataAsset : public UDataAsset
{
	GENERATED_BODY()

public:

#if WITH_EDITORONLY_DATA
	static FString FileExtension;

	UPROPERTY(VisibleAnywhere, Instanced, Category = "ImportSettings")
	UAssetImportData* AssetImportData;
#endif

#if WITH_EDITOR
	UFUNCTION(Category = "Import/Export", meta = (CallInEditor = true))
	void Import();

	UFUNCTION(Category = "Import/Export", meta = (CallInEditor = true))
	void Export();

	UFUNCTION(Category = "Import/Export", meta = (CallInEditor = true))
	void OpenSourceLocation() const;

	void PostEditChangeProperty(FPropertyChangedEvent & PropertyChangedEvent);

	void UpdateAssetImportData(FString Filename);
#endif

};
