// Fill out your copyright notice in the Description page of Project Settings.

#if WITH_EDITORONLY_DATA
#pragma once

#include "CoreMinimal.h"
#include "Factories/Factory.h"
#include "EditorReimportHandler.h"
#include "MyDataAssetFactory.generated.h"

UCLASS()
class MYPROJECT_API UMyDataAssetFactory : public UFactory, public FReimportHandler
{
	GENERATED_BODY()

public:

	UMyDataAssetFactory(const FObjectInitializer& ObjectInitializer);

	virtual bool DoesSupportClass(UClass* Class) override;
	virtual UClass* ResolveSupportedClass() override;
	virtual UObject* FactoryCreateText(UClass* InClass, UObject* InParent, FName InName, EObjectFlags Flags, UObject* Context, const TCHAR* Type, const TCHAR*& Buffer, const TCHAR* BuferEnd, FFeedbackContext* Warn) override;

	virtual bool CanReimport(UObject* Obj, TArray<FString>& OutFilenames) override;
	virtual void SetReimportPaths(UObject* Obj, const TArray<FString>& NewReimportPaths) override;
	virtual EReimportResult::Type Reimport(UObject* Obj) override;
};
#endif
