// Fill out your copyright notice in the Description page of Project Settings.

#include "MyProject.h"

#if WITH_EDITORONLY_DATA
#include "MyProject/MyDataAsset/AssetTypeActions_MyDataAsset.h"
#endif

#define LOCTEXT_NAMESPACE "FMyProjectModule"

void FMyProjectModule::StartupModule()
{
#if WITH_EDITORONLY_DATA
	MyDataAsset_AssetTypeActions = MakeShareable(new FAssetTypeActions_MyDataAsset);
	FModuleManager::LoadModuleChecked<FAssetToolsModule>("AssetTools").Get().RegisterAssetTypeActions(MyDataAsset_AssetTypeActions.ToSharedRef());
#endif
}

void FMyProjectModule::ShutdownModule()
{
#if WITH_EDITORONLY_DATA
	if (MyDataAsset_AssetTypeActions.IsValid())
	{
		if (FModuleManager::Get().IsModuleLoaded("AssetTools"))
		{
			FModuleManager::GetModuleChecked<FAssetToolsModule>("AssetTools").Get().UnregisterAssetTypeActions(MyDataAsset_AssetTypeActions.ToSharedRef());
		}
		MyDataAsset_AssetTypeActions.Reset();
	}
#endif
}

#undef LOCTEXT_NAMESPACE

IMPLEMENT_MODULE(FMyProjectModule, MyProject)
