// Fill out your copyright notice in the Description page of Project Settings.

#pragma once

#include "CoreMinimal.h"
#include "Engine/DeveloperSettings.h"
#include "MySettings.generated.h"

UCLASS(config = "MySettings", defaultconfig)
class MYPROJECT_API UMySettings : public UDeveloperSettings
{
	GENERATED_BODY()
	
public:
	
	UMySettings();

#if WITH_EDITORONLY_DATA
	// t@C̏o͐tH_[
	UPROPERTY(BlueprintReadWrite, EditAnywhere, Config, Category = "Data")
	FString ResourceOutputFolder;

	// GNX|[g@\ ON/OFF
	UPROPERTY(BlueprintReadWrite, EditAnywhere, Config, Category = "Data")
	bool AutoExportOnEdit;
#endif

	UFUNCTION(BlueprintPure)
	static UMySettings *GetMySettings();

	virtual FName GetCategoryName() const override;

#if WITH_EDITOR
	virtual FText GetSectionText() const override;
	virtual FText GetSectionDescription() const override;
#endif

};
